Index: trunk/zoo-services/ogr/base-vect-ops/service.c
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/service.c	(revision 34)
+++ trunk/zoo-services/ogr/base-vect-ops/service.c	(revision 35)
@@ -91,5 +91,5 @@
     free(tmp);
     if(res==NULL){
-      setMapInMaps(conf,"lenv","message","Unable to call OGR_G_CreatFromGML");
+      setMapInMaps(conf,"lenv","message",_("Unable to call OGR_G_CreatFromGML"));
       return NULL;
     }
@@ -111,5 +111,5 @@
     map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
     if(!tmp){
-      setMapInMaps(conf,"lenv","message","Unagle to parse the input geometry from InputPolygon");
+      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -123,9 +123,9 @@
     }
     else{
-      setMapInMaps(conf,"lenv","message","Unable to find any geometry for InputPolygon");
+      setMapInMaps(conf,"lenv","message",_("Unable to find any geometry for InputPolygon"));
       return SERVICE_FAILED;
     }
     if(geometry==NULL){
-      setMapInMaps(conf,"lenv","message","Unagle to parse the input geometry from InputPolygon");
+      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -178,6 +178,8 @@
 #endif
     map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
-    if(!tmp)
-      return SERVICE_FAILED;
+    if(!tmp){
+      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
+      return SERVICE_FAILED;
+    }
     fprintf(stderr,"Service internal print \n");
     dumpMaps(inputs);
@@ -196,6 +198,8 @@
     else
       geometry=createGeometryFromGML(conf,tmp->value);
-    if(geometry==NULL)
-      return SERVICE_FAILED;
+    if(geometry==NULL){
+      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
+      return SERVICE_FAILED;
+    }
     res=(*myFunc)(geometry);
     fprintf(stderr,"Service internal print \n");
@@ -252,9 +256,9 @@
    map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
    if(tmp==NULL){
-     setMapInMaps(conf,"lenv","message","Unable to fetch input geometry");
+     setMapInMaps(conf,"lenv","message",_("Unable to fetch input geometry"));
      return SERVICE_FAILED;
    }else
      if(strlen(tmp->value)<=0){
-       setMapInMaps(conf,"lenv","message","Unable to fetch input geometry");
+       setMapInMaps(conf,"lenv","message",_("Unable to fetch input geometry"));
        return SERVICE_FAILED;
      }
@@ -265,5 +269,5 @@
      geometry=createGeometryFromGML(conf,tmp->value);
    if(geometry==NULL){
-     setMapInMaps(conf,"lenv","message","Unable to parse input geometry");
+     setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry"));
      return SERVICE_FAILED;
    }
@@ -287,4 +291,5 @@
      char *tmpS=OGR_G_ExportToGML(res);
      setMapInMaps(outputs,"Result","value",tmpS);
+     free(tmpS);
      setMapInMaps(outputs,"Result","mimeType","text/xml");
      setMapInMaps(outputs,"Result","encoding","UTF-8");
@@ -355,5 +360,5 @@
     }
     if(geometry1==NULL){
-      setMapInMaps(conf,"lenv","message","Unable to parse input geometry for InputEntity1.");
+      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry for InputEntity1."));
       fprintf(stderr,"SERVICE FAILED !\n");
       return SERVICE_FAILED;
@@ -385,5 +390,5 @@
     fprintf(stderr,"\nService internal print1 InputEntity2 Final\n");
     if(geometry2==NULL){
-      setMapInMaps(conf,"lenv","message","Unable to parse input geometry for InputEntity2.");
+      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry for InputEntity2."));
       fprintf(stderr,"SERVICE FAILED !\n");
       return SERVICE_FAILED;
@@ -461,5 +466,5 @@
     }
     if(geometry1==NULL){
-      setMapInMaps(conf,"lenv","message","Unable to parse input geometry for InputEntity1.");
+      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry for InputEntity1."));
       fprintf(stderr,"SERVICE FAILED !\n");
       return SERVICE_FAILED;
@@ -512,5 +517,5 @@
     map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
     if(tmp==NULL){
-      setMapInMaps(conf,"lenv","message","Unable to parse input geometry from InputPolygon");
+      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -518,5 +523,5 @@
     geometry=createGeometryFromGML(conf,tmp->value);
     if(geometry==NULL){
-      setMapInMaps(conf,"lenv","message","Unable to parse input geometry from InputPolygon");
+      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }