Index: trunk/zoo-services/ogr/base-vect-ops/service.c
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/service.c	(revision 35)
+++ trunk/zoo-services/ogr/base-vect-ops/service.c	(revision 36)
@@ -23,8 +23,4 @@
  */
 
-#include <libintl.h>
-#include <locale.h>
-#define _(String) dgettext ("zoo-services",String)
-
 #include "cpl_conv.h"
 #include "ogr_api.h"
@@ -32,5 +28,5 @@
 #include "geos_c.h"
 #include "service.h"
-
+#include "service_internal.h"
 
 extern "C" {
@@ -91,5 +87,5 @@
     free(tmp);
     if(res==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to call OGR_G_CreatFromGML"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to call OGR_G_CreatFromGML"));
       return NULL;
     }
@@ -111,5 +107,5 @@
     map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
     if(!tmp){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse the input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -123,9 +119,9 @@
     }
     else{
-      setMapInMaps(conf,"lenv","message",_("Unable to find any geometry for InputPolygon"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to find any geometry for InputPolygon"));
       return SERVICE_FAILED;
     }
     if(geometry==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse the input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -179,5 +175,5 @@
     map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
     if(!tmp){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse the input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -199,5 +195,5 @@
       geometry=createGeometryFromGML(conf,tmp->value);
     if(geometry==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse the input geometry from InputPolygon"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse the input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -256,9 +252,9 @@
    map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
    if(tmp==NULL){
-     setMapInMaps(conf,"lenv","message",_("Unable to fetch input geometry"));
+     setMapInMaps(conf,"lenv","message",_ss("Unable to fetch input geometry"));
      return SERVICE_FAILED;
    }else
      if(strlen(tmp->value)<=0){
-       setMapInMaps(conf,"lenv","message",_("Unable to fetch input geometry"));
+       setMapInMaps(conf,"lenv","message",_ss("Unable to fetch input geometry"));
        return SERVICE_FAILED;
      }
@@ -269,5 +265,5 @@
      geometry=createGeometryFromGML(conf,tmp->value);
    if(geometry==NULL){
-     setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry"));
+     setMapInMaps(conf,"lenv","message",_ss("Unable to parse input geometry"));
      return SERVICE_FAILED;
    }
@@ -360,5 +356,5 @@
     }
     if(geometry1==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry for InputEntity1."));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse input geometry for InputEntity1."));
       fprintf(stderr,"SERVICE FAILED !\n");
       return SERVICE_FAILED;
@@ -390,5 +386,5 @@
     fprintf(stderr,"\nService internal print1 InputEntity2 Final\n");
     if(geometry2==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry for InputEntity2."));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse input geometry for InputEntity2."));
       fprintf(stderr,"SERVICE FAILED !\n");
       return SERVICE_FAILED;
@@ -466,5 +462,5 @@
     }
     if(geometry1==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry for InputEntity1."));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse input geometry for InputEntity1."));
       fprintf(stderr,"SERVICE FAILED !\n");
       return SERVICE_FAILED;
@@ -489,5 +485,5 @@
     }
     if(geometry2==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry for InputEntity2."));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse input geometry for InputEntity2."));
       fprintf(stderr,"SERVICE FAILED !\n");
       return SERVICE_FAILED;
@@ -517,5 +513,5 @@
     map* tmp=getMapFromMaps(inputs,"InputPolygon","value");
     if(tmp==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry from InputPolygon"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }
@@ -523,5 +519,5 @@
     geometry=createGeometryFromGML(conf,tmp->value);
     if(geometry==NULL){
-      setMapInMaps(conf,"lenv","message",_("Unable to parse input geometry from InputPolygon"));
+      setMapInMaps(conf,"lenv","message",_ss("Unable to parse input geometry from InputPolygon"));
       return SERVICE_FAILED;
     }