Index: /trunk/zoo-services/ogr/ogr2ogr/service.c
===================================================================
--- /trunk/zoo-services/ogr/ogr2ogr/service.c	(revision 38)
+++ /trunk/zoo-services/ogr/ogr2ogr/service.c	(revision 39)
@@ -547,8 +547,8 @@
 	{
 #endif
-        Usage();
-#ifdef ZOO_SERVICE
-		setMapInMaps(conf,"lenv","message","Wrong parameter");
-		return SERVICE_FAILED;
+	  Usage();
+#ifdef ZOO_SERVICE
+	  setMapInMaps(conf,"lenv","message","Wrong parameter");
+	  return SERVICE_FAILED;
 	}
 #endif
@@ -577,8 +577,8 @@
         }
 #ifdef ZOO_SERVICE
-		char tmp[1024];
-		sprintf(tmp,"Unable to open datasource `%s' with the following drivers.",pszDataSource);
-		setMapInMaps(conf,"lenv","message",tmp);
-		return SERVICE_FAILED;
+	char tmp[1024];
+	sprintf(tmp,"Unable to open datasource `%s' with the following drivers.",pszDataSource);
+	setMapInMaps(conf,"lenv","message",tmp);
+	return SERVICE_FAILED;
 #else
         exit( 1 );
@@ -600,8 +600,8 @@
                     pszDestDataSource );
 #ifdef ZOO_SERVICE
-		char tmp[1024];
-		sprintf(tmp,"Unable to open existing output datasource `%s'.",pszDestDataSource);
-		setMapInMaps(conf,"lenv","message",tmp);
-		return SERVICE_FAILED;
+	    char tmp[1024];
+	    sprintf(tmp,"Unable to open existing output datasource `%s'.",pszDestDataSource);
+	    setMapInMaps(conf,"lenv","message",tmp);
+	    return SERVICE_FAILED;
 #else
         exit( 1 );
@@ -645,8 +645,8 @@
             }
 #ifdef ZOO_SERVICE
-			char tmp[1024];
-			sprintf(tmp,"Unable to find driver `%s'.",pszFormat);
-			setMapInMaps(conf,"lenv","message",tmp);
-			return SERVICE_FAILED;
+	    char tmp[1024];
+	    sprintf(tmp,"Unable to find driver `%s'.",pszFormat);
+	    setMapInMaps(conf,"lenv","message",tmp);
+	    return SERVICE_FAILED;
 #else
             exit( 1 );
@@ -659,8 +659,8 @@
                     pszFormat );
 #ifdef ZOO_SERVICE
-			char tmp[1024];
-			sprintf(tmp,"%s driver does not support data source creation.",pszFormat);
-			setMapInMaps(conf,"lenv","message",tmp);
-			return SERVICE_FAILED;
+	    char tmp[1024];
+	    sprintf(tmp,"%s driver does not support data source creation.",pszFormat);
+	    setMapInMaps(conf,"lenv","message",tmp);
+	    return SERVICE_FAILED;
 #else
             exit( 1 );
@@ -677,8 +677,8 @@
                     pszFormat, pszDestDataSource );
 #ifdef ZOO_SERVICE
-			char tmp[1024];
-			sprintf(tmp,"%s driver failed to create %s",pszFormat, pszDestDataSource);
-			setMapInMaps(conf,"lenv","message",tmp);
-			return SERVICE_FAILED;
+	    char tmp[1024];
+	    sprintf(tmp,"%s driver failed to create %s",pszFormat, pszDestDataSource);
+	    setMapInMaps(conf,"lenv","message",tmp);
+	    return SERVICE_FAILED;
 #else
             exit( 1 );
@@ -698,8 +698,8 @@
                     pszOutputSRSDef );
 #ifdef ZOO_SERVICE
-			char tmp[1024];
-			sprintf(tmp,"Failed to process SRS definition: %s",pszOutputSRSDef);
-			setMapInMaps(conf,"lenv","message",tmp);
-			return SERVICE_FAILED;
+	    char tmp[1024];
+	    sprintf(tmp,"Failed to process SRS definition: %s",pszOutputSRSDef);
+	    setMapInMaps(conf,"lenv","message",tmp);
+	    return SERVICE_FAILED;
 #else
             exit( 1 );
@@ -719,8 +719,8 @@
                     pszSourceSRSDef );
 #ifdef ZOO_SERVICE
-			char tmp[1024];
-			sprintf(tmp,"Failed to process SRS definition: %s",pszOutputSRSDef);
-			setMapInMaps(conf,"lenv","message",tmp);
-			return SERVICE_FAILED;
+	    char tmp[1024];
+	    sprintf(tmp,"Failed to process SRS definition: %s",pszOutputSRSDef);
+	    setMapInMaps(conf,"lenv","message",tmp);
+	    return SERVICE_FAILED;
 #else
             exit( 1 );
@@ -775,10 +775,10 @@
                     iLayer );
 #ifdef ZOO_SERVICE
-			char tmp[1024];
-			sprintf(tmp,"Couldn't fetch advertised layer %d!",iLayer);
-			setMapInMaps(conf,"lenv","message",tmp);
-			return SERVICE_FAILED;
-#else
-			exit( 1 );
+	    char tmp[1024];
+	    sprintf(tmp,"Couldn't fetch advertised layer %d!",iLayer);
+	    setMapInMaps(conf,"lenv","message",tmp);
+	    return SERVICE_FAILED;
+#else
+	    exit( 1 );
 #endif
         }
@@ -806,8 +806,8 @@
 
 #ifdef ZOO_SERVICE
-				char tmp[1024];
-				sprintf(tmp,"Terminating translation prematurely after failed of layer %s",poLayer->GetLayerDefn()->GetName() );
-				setMapInMaps(conf,"lenv","message",tmp);
-				return SERVICE_FAILED;
+		char tmp[1024];
+		sprintf(tmp,"Terminating translation prematurely after failed of layer %s",poLayer->GetLayerDefn()->GetName() );
+		setMapInMaps(conf,"lenv","message",tmp);
+		return SERVICE_FAILED;
 #else
                 exit( 1 );